--[[============================================================================
main.lua
============================================================================]]--

local rs, pattern, line, step, track, column, nv

--------------------------------------------------------------------------------
-- Main function
--------------------------------------------------------------------------------

local function pushback_delay_column(mm)
  rs = renoise.song()
  nv = mm.int_value * 2
  rs.transport.follow_player = false
  pattern = rs.sequencer:pattern(rs.transport.edit_pos.sequence)
  line = rs.transport.edit_pos.line
  step = rs.transport.edit_step
  track = rs.selected_track_index
  column = rs.selected_note_column_index
  rs:track(track).delay_column_visible = true
  if step <= 1 then step = 1 line = 1 end
--  if column > 0 and column <= 12 then
    local x = line
    while x > step do x = x - step end
    for i = x, rs:pattern(pattern).number_of_lines, step do
      rs:pattern(pattern):track(track):line(i):note_column(column).delay_value = nv
    end
--  end
end

--------------------------------------------------------------------------------
-- MIDI Mapping
--------------------------------------------------------------------------------

renoise.tool():add_midi_mapping {
  name = "Tools:Push back",
  invoke = function(mm) pushback_delay_column(mm) end
}
